/*************************************************************************

      Graphics Research Group - Department of Computer Science
                  University of Sheffield, UK
                      Michael Meredith
                     Copyright (c) 2000
                    All Rights Reserved.


  Permission is hereby granted, free of charge, to use this software 
  and its documentation without restriction, including without limitation 
  the rights to use, copy, modify, merge and publish, subject to the following 
  conditions:

   1. The code must retain the above copyright notice, this list of
      conditions and the following disclaimer.

   2. Any modifications must be clearly marked as such.

   3. Original authors' names are not deleted.

   4. The authors' names are not used to endorse or promote products
      derived from this software without specific prior written
      permission from the author.

   5. This software is used in a research, non-profit capacity only and not 
      for commercial or profit applications unless specific prior written
      permission from the author is given.


  THE UNIVERSITY OF SHEFFIELD AND THE CONTRIBUTORS TO THIS WORK
  DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
  ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT
  SHALL THE UNIVERSITY OF SHEFFIELD NOR THE CONTRIBUTORS BE LIABLE
  FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
  AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
  ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
  THIS SOFTWARE.

*************************************************************************/

#ifndef __displaygl_h__
#define __displaygl_h__

#include <afxwin.h>
#include "gl\gl.h"
#include "gl\glu.h"
#include "gl\glaux.h"
#include "Extras.h"

class DisplayGL : public CWnd//, public CWinThread, 
{
public:
  DisplayGL();
  ~DisplayGL();
  void SetupSegments(NODE* segs, MOCAPHEADER* header);  // Used to pass the display a body structure that holds all of the required information
  void Draw();                                          // Redraws the 3D object
  MOCAPHEADER* header;

private:
  NODE* body;
  HGLRC hrc;
	CClientDC*	m_pDC;
  CPalette m_cPalette, *m_pOldPalette;

  DWORD lasttime;
  long  frames;
  char fps[6];

  CPoint last;
  float centre[3];

  void Init();                          // Initilises GL display area
	void CreateRGBPalette();              // Used to set up the window colours when using fewer colours than 16bit
  BOOL bSetupPixelFormat();             // Used to set up the window pixel format
  unsigned char ComponentFromIndex(int i, UINT nbits, UINT shift);  // Aux function to CreateRGBPalette

  void EvaluateChildren(NODE* node);    // Used recursively to locate and position child nodes in the hier

protected:
  afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
  afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
  afx_msg void OnMouseMove(UINT nFlags, CPoint point);
  afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);    // Called when the window is created
 	afx_msg void OnPaint();                                 // Called when repainting needs to be done
  afx_msg void OnSize(UINT nType, int cx, int cy);        // Called when the window is resized
  DECLARE_MESSAGE_MAP()

};
#endif